
function iirtable(b,a,fname)
%
%  iirtable(b,a,fname)
%
%  Produce a factorization of B(z)/A(z) 
% for a scaled cascade of second order section.
% It is Assumed that B and A are both even order
% 'fname' is the name of the file to be created
%
h=filter(b,a,[1,zeros(1,14)]);
fn=[fname,'.asm'];
fid=fopen(fn,'wt')
c=[];
g=1;
beta=b(1);
n=length(b)-1;
beta=beta^(2/n);
while length(a) > 1
   r=roots(a);
   aa=real(conv([1,-r(1)],[1,-conj(r(1))]));
   [a,r]=deconv(a,aa);
   r=roots(b);
   bb=real(conv([1,-r(1)],[1,-conj(r(1))]));
   [b,r]=deconv(b,bb);
   bb=beta*bb;
   gg=max(abs(fft(bb,1024)./fft(aa,1024)));
   aaa=-.5*[aa(2),aa(3)];
   if gg < g
      c=[bb,aaa,c];
   else
      c=[c,bb,aaa];
      g=gg;
   end
end
fprintf(fid,'; file %s\n',fn);
fprintf(fid,'; coefficients for an IIR filter of order %d\n',n);
fprintf(fid,';  line 1 contains the number of second order sections\n');
fprintf(fid,';  line 2 contains the number (order+2)for M register\n');
fprintf(fid,';  then, in groups of five, come b0,b1,b2,-a1/2,-a2/2\n');
fprintf(fid,'; unit pulse response begins with\n');
fprintf(fid,'; %1.6g %1.6g %1.6g %1.6g %1.6g \n',h);
fprintf(fid,' dc %d\n',n/2);
fprintf(fid,' dc %d\n',n+2);
for k=1:length(c)
   fprintf(fid,' dc %1.12g\n',c(k));
end
fclose(fid)





