function scope(b,a,fs)
% scope(b,a,fs)
%
% Make three plots for the
% filter H(z)=B(z)/A(z)
% (1) plotzt
% (2) plot the continuous time impulse and step
%  responses h and g
% (3) plotsig(h,fs)
%
M=8; % upsample ratio
u=[1,zeros(1,1024)];
h0=filter(b,a,u);
k=[0:length(h0)-1];
m=round(sum(k.*h0.*h0)/sum(h0.*h0));
m=min(4*m,length(h0));
figure(1)
plotzt(b,a,0,m)
figure(2)
h0=h0([1:m]);
fs1=M*fs;
ts1=1/fs1;
h=fs*d_up(h0,M,3);
t=ts1*[0:length(h)-1];
g=ts1*cumsum(h);
subplot(2,1,1)
plot(t,h)
xlabel('impulse response')
subplot(2,1,2)
plot(t,g)
xlabel('step response')

